<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingemerald extends JPlugin
{
	function plgAcymailingemerald(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onAcyDisplayFilters(&$type){
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_emerald')) return '';
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id, name FROM #__emerald_plans WHERE published = 1 ORDER BY name ASC');
		$allPlans = $db->loadObjectList();
		$plans = array();
		$plans[] = JHTML::_('select.option', 0, 'Any');
		foreach($allPlans as $onePlan){
			$plans[] = JHTML::_('select.option', $onePlan->id, $onePlan->name);
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_emerald',JPATH_SITE);

		$status = array();
		$status[] = JHTML::_('select.option', '0', JText::_('ALL_STATUS'));
		$status[] = JHTML::_('select.option', '1', JText::_('JOOMEXT_YES'));
		$status[] = JHTML::_('select.option', '-1', JText::_('JOOMEXT_NO'));

		$inoperator = acymailing_get('type.operatorsin');
		$inoperator->js = 'onchange="countresults(__num__)"';

		$return = '<div id="filter__num__emeraldsub">';
		$return .= $inoperator->display('filter[__num__][emeraldsub][type]').JHTML::_('select.genericlist', $plans, 'filter[__num__][emeraldsub][planid]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= ' '.JText::_('ACTIVATED').': '.JHTML::_('select.genericlist', $status, 'filter[__num__][emeraldsub][substate]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br /> <input type="text" name="filter[__num__][emeraldsub][cdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" /> < '.JText::_('CREATED_DATE').' < <input type="text" name="filter[__num__][emeraldsub][cdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" />';
		$return .= '<br /> <input type="text" name="filter[__num__][emeraldsub][pdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" /> < '.(JText::_('EPLUNLIST') == 'EPLUNLIST' ? 'Purchase Date' : JText::_('EPLUNLIST')).' < <input type="text" name="filter[__num__][emeraldsub][pdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" />';
		$return .= '</div>';
		$type['emeraldsub'] = 'Emerald';
		$acyconfig = acymailing_config();
		if(version_compare($acyconfig->get('version'),'4.9.3','<')) echo 'Please update AcyMailing, the Emerald plugin may not work properly with this version';

		return $return;
	}

	function onAcyProcessFilterCount_emeraldsub(&$query,$filter,$num){
		$this->onAcyProcessFilter_emeraldsub($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_emeraldsub(&$query,$filter,$num){
		$join = '#__emerald_subscriptions AS emerald'.$num.' ON sub.userid = emerald'.$num.'.user_id'.(empty($filter['planid']) ? '' : ' AND emerald'.$num.'.plan_id = '.intval($filter['planid']));
		$where = array();

	 	if(!empty($filter['cdateinf'])){
	 		$filter['cdateinf'] = acymailing_replaceDate($filter['cdateinf']);
	 		if(!is_numeric($filter['cdateinf'])) $filter['cdateinf'] = strtotime($filter['cdateinf']);
	 		if(is_numeric($filter['cdateinf'])) $filter['cdateinf'] = strftime('%Y-%m-%d %H:%M:%S',$filter['cdateinf']);
		 	$where[] = 'emerald'.$num.'.created > '.$query->db->Quote($filter['cdateinf']);
	 	}

	 	if(!empty($filter['cdatesup'])){
	 		$filter['cdatesup'] = acymailing_replaceDate($filter['cdatesup']);
	 		if(!is_numeric($filter['cdatesup'])) $filter['cdatesup'] = strtotime($filter['cdatesup']);
	 		if(is_numeric($filter['cdatesup'])) $filter['cdatesup'] = strftime('%Y-%m-%d %H:%M:%S',$filter['cdatesup']);
		 	$where[] = 'emerald'.$num.'.created < '.$query->db->Quote($filter['cdatesup']);
	 	}

	 	if(!empty($filter['pdateinf'])){
	 		$filter['pdateinf'] = acymailing_replaceDate($filter['pdateinf']);
	 		if(!is_numeric($filter['pdateinf'])) $filter['pdateinf'] = strtotime($filter['pdateinf']);
	 		if(is_numeric($filter['pdateinf'])) $filter['pdateinf'] = strftime('%Y-%m-%d %H:%M:%S',$filter['pdateinf']);
		 	$where[] = 'emerald'.$num.'.purchased > '.$query->db->Quote($filter['pdateinf']);
	 	}

	 	if(!empty($filter['pdatesup'])){
	 		$filter['pdatesup'] = acymailing_replaceDate($filter['pdatesup']);
	 		if(!is_numeric($filter['pdatesup'])) $filter['pdatesup'] = strtotime($filter['pdatesup']);
	 		if(is_numeric($filter['pdatesup'])) $filter['pdatesup'] = strftime('%Y-%m-%d %H:%M:%S',$filter['pdatesup']);
		 	$where[] = 'emerald'.$num.'.purchased < '.$query->db->Quote($filter['pdatesup']);
	 	}

		if(!empty($filter['substate'])){
			if($filter['substate'] == 1){
				$where[] = 'emerald'.$num.'.extime > NOW() OR emerald'.$num.'.extime = "0000-00-00 00:00:00"';
				$where[] = 'emerald'.$num.'.ctime < NOW()';
				$where[] = 'emerald'.$num.'.activated = 1';
				$where[] = 'emerald'.$num.'.published = 1';
				$where[] = 'emerald'.$num.'.access_limit = 0 OR (emerald'.$num.'.access_limit > 0 AND emerald'.$num.'.access_count < emerald'.$num.'.access_limit)';
			}else{
				$where[] = 'emerald'.$num.'.extime < NOW() ' .
							'OR emerald'.$num.'.ctime > NOW() ' .
							'OR emerald'.$num.'.activated <> 1 ' .
							'OR (emerald'.$num.'.access_limit > 0 ' .
								'AND emerald'.$num.'.access_count >= emerald'.$num.'.access_limit) ' .
							'OR emerald'.$num.'.published <> 1';
			}
		}

	 	if(!empty($where)) $join .= ' AND ('.implode(') AND (', $where).')';

		if($filter['type'] == 'IN'){
			$query->join['emerald'.$num] = $join;
		}else{
			$query->leftjoin['emerald'.$num] = $join;
			$query->where['emerald'.$num] = 'emerald'.$num.'.plan_id IS NULL';
		}
	}
}//endclass